<?php

if (!defined('SMF'))
	die('Hacking attempt...');

function ForceReadTopicsAdminArea(&$admin_areas)
{
	global $txt;
	
	loadLanguage('ForceReadTopics');
	
	return $admin_areas['config']['areas']['modsettings']['subsections'] += array('forcereadtopics' => array(sprintf($txt['forcereadtopics_settings'], '')));
}

function ForceReadTopicsSubAction(&$subActions)
{
	return $subActions += array('forcereadtopics' => 'ForceReadTopicsSettings');
}

function ForceReadTopicsSettings($return_config = false) 
{
	global $context, $txt, $scripturl, $modSettings, $smcFunc;
	
	loadLanguage('ForceReadTopics');
	
	$context['page_title'] = $txt['forcereadtopics_settings'];

	$config_vars = array(
	    array('check', 'force_read_topic_enable'),
		array('int', 'force_read_topic_id'),
		array('text', 'force_read_excluded_groups'),
	);

	if ($return_config)
		return $config_vars;

	if (isset($_GET['save'])) 
	{
		checkSession();

		saveDBSettings($config_vars);
		
		// Check that topic exists
	    $request = $smcFunc['db_query']('', '
		   SELECT id_topic
		     FROM {db_prefix}topics
		   WHERE id_topic = ({int:topic})
		  ',
		   array(
			  'topic' => $modSettings['force_read_topic_id'],
		   )
	   );
	
	if ($smcFunc['db_num_rows']($request) == 0)
		fatal_lang_error('no_topic_found', false);
		
		if (!empty($modSettings['force_read_topic_enable']) && !empty($modSettings['force_read_topic_id']))
		{
		    // Just delete the rows when changing settings...
	        $smcFunc['db_query']('', '
		        DELETE FROM {db_prefix}force_users_topic_read'
	        );
		}
		
		writeLog();

		redirectexit('action=admin;area=modsettings;sa=forcereadtopics');
	}

	$context['post_url'] = $scripturl . '?action=admin;area=modsettings;save;sa=forcereadtopics';

	prepareDBSettingContext($config_vars);
}

function force_users_read_topic()
{
	global $smcFunc, $topic, $modSettings, $user_info, $txt;
	
	$excluded_groups = !empty($modSettings['force_read_excluded_groups']) ? explode(",", $modSettings['force_read_excluded_groups']) : array();
	
	if (!empty($topic) && !empty($modSettings['force_read_topic_enable']) && !empty($modSettings['force_read_topic_id']) && !$user_info['is_guest'] && !$user_info['is_admin'] && count(array_intersect($user_info['groups'], $excluded_groups)) == 0)
	{
	    $request = $smcFunc['db_query']('', '
              SELECT * FROM {db_prefix}force_users_topic_read
              WHERE user_id = {int:user_id}
              LIMIT 1',
              array(
                  'user_id' => $user_info['id'],
              )
        );
      
        list ($forcethread) = $smcFunc['db_fetch_row']($request);

        $smcFunc['db_free_result']($request);
			
	    if($topic != $modSettings['force_read_topic_id'] && !$forcethread)
	    {
		    loadLanguage('ForceReadTopics');
		    fatal_lang_error($txt['you_must_read_topic'], false);
	    }
	    elseif(!$forcethread)
	    {	
		    $smcFunc['db_insert']('ignore',
			     '{db_prefix}force_users_topic_read',
			     array('user_id' => 'int', 'topic_id' => 'int'),
			     array($user_info['id'], $modSettings['force_read_topic_id']),
			     array('user_id', 'topic_id')
	        );
	    }	
    }		
}